Index: lib/TWiki.pm
===================================================================
--- lib/TWiki.pm	(revision 1767)
+++ lib/TWiki.pm	(working copy)
@@ -2693,521 +1917,407 @@
         }
     }
     $value =~ s/\r?\n/$newLine/go if( $newLine );
-    $value = handleUrlEncode( $value, 0, $encode ) if( $encode );
+    if ( $encode && $encode =~ /^entit(y|ies)$/ ) {
+        $value = entityEncode( $value );
+    } else {
+        $value = _urlEncode( $value );
+    }
     unless( $value ) {
-        $value = $params{"default"} || "";
+        $value = $params->{default} || "";
     }
     return $value;
 }
 
-# =========================
-# Encode to URL parameter or HTML entity
-# TODO: For non-ISO-8859-1 $siteCharset, need to convert to Unicode 
-# for use in entity, or to UTF-8 before URL encoding.
-
 =pod
 
----++ sub handleUrlEncode (  $theArgs, $doExtract  )
+---++ entityEncode (text )
+| =$text= | Text to encode |
+Escape certain characters to HTML entities
 
-Not yet documented.
-
 =cut
 
-sub handleUrlEncode
-{
-    my( $theArgs, $doExtract, $theType ) = @_;
+sub entityEncode {
+    my $text = shift;
 
-    my $text = $theArgs;
-    my $type = $theType || "";
-    if( $doExtract ) {
-        $text = extractNameValuePair( $theArgs );
-        $type = extractNameValuePair( $theArgs, "type" ) || "";
-    }
-    if( $type =~ /^entit(y|ies)$/i ) {
-        # HTML entity encoding
-	# TODO: Encode characters > 0x7F to Unicode first
-        $text =~ s/\"/\&\#034;/g;
-        $text =~ s/\%/\&\#037;/g;
-        $text =~ s/\*/\&\#042;/g;
-        $text =~ s/\_/\&\#095;/g;
-        $text =~ s/\=/\&\#061;/g;
-        $text =~ s/\[/\&\#091;/g;
-        $text =~ s/\]/\&\#093;/g;
-        $text =~ s/\</\&\#060;/g;
-        $text =~ s/\>/\&\#062;/g;
-        $text =~ s/\|/\&\#124;/g;
-    } else {
-        # URL encoding
-        $text =~ s/[\n\r]/\%3Cbr\%20\%2F\%3E/g;
-        $text =~ s/\s+/\%20/g;
-        $text =~ s/\"/\%22/g;
-        $text =~ s/\&/\%26/g;
-        $text =~ s/\+/\%2B/g;
-        $text =~ s/\</\%3C/g;
-        $text =~ s/\>/\%3E/g;
-        $text =~ s/\\/\%5C/g;
-        # Encode characters > 0x7F (ASCII-derived charsets only)
-	# TODO: Encode to UTF-8 first
-        $text =~ s/([\x7f-\xff])/'%' . unpack( "H*", $1 ) /ge;
-    }
+    # HTML entity encoding
+    $text =~ s/([\"\%\*\_\=\[\]\<\>\|])/"\&\#".ord( $1 ).";"/ge;
     return $text;
 }
 
+# Generate a $w-char hexidecimal number representing $n.
+# Default $w is 2 (one byte)
+sub _hexchar {
+    my( $n, $w ) = @_;
+    $w = 2 unless $w;
+    return sprintf( "%0${w}x", ord( $n ));
+}
 
-=pod
+# Encode to URL parameter
+# TODO: For non-ISO-8859-1 $siteCharset, need to convert to
+# UTF-8 before URL encoding.
+# | =$text= | Text to encode |
+# SMELL: what is the relationship to nativeUrlEncode??
+sub _urlEncode {
+    my $text = shift;
 
----++ sub handleNativeUrlEncode ( $theStr, $doExtract )
+    # URL encoding
+    $text =~ s/[\n\r]/\%3Cbr\%20\%2F\%3E/g;
+    $text =~ s/\s/\%20/g;
+    $text =~ s/(["&+<>\\])/"%"._hexchar($1,2)/ge;
+    # Encode characters > 0x7F (ASCII-derived charsets only)
+	# TODO: Encode to UTF-8 first
+    $text =~ s/([\x7f-\xff])/'%' . unpack( "H*", $1 ) /ge;
 
+    return $text;
+}
+
+=pod
+
+---++ nativeUrlEncode ( $theStr, $doExtract )
 Perform URL encoding into native charset ($siteCharset) - for use when
 viewing attachments via browsers that generate UTF-8 URLs, on sites running
 with non-UTF-8 (Native) character sets.  Aim is to prevent UTF-8 URL
 encoding.  For mainframes, we assume that UTF-8 URLs will be translated
 by the web server to an EBCDIC character set.
 
+SMELL: why is this different to _urlEncode?
+
 =cut
 
-sub handleNativeUrlEncode {
-    my( $theStr, $doExtract ) = @_;
+sub nativeUrlEncode {
+    my $theStr = shift;
 
     my $isEbcdic = ( 'A' eq chr(193) ); 	# True if Perl is using EBCDIC
 
     if( $siteCharset eq "utf-8" or $isEbcdic ) {
-	# Just strip double quotes, no URL encoding - let browser encode to
-	# UTF-8 or EBCDIC based $siteCharset as appropriate
-	$theStr =~ s/^"(.*)"$/$1/;	
-	return $theStr;
+        # Just strip double quotes, no URL encoding - let browser encode to
+        # UTF-8 or EBCDIC based $siteCharset as appropriate
+        $theStr =~ s/^"(.*)"$/$1/;	
+        return $theStr;
     } else {
-	return handleUrlEncode( $theStr, $doExtract );
+        return _urlEncode( $theStr );
     }
 }
 
-=pod
-
----++ sub handleIntUrlEncode ( $theStr, $doExtract )
-
-This routine was introduced to URL encode Mozilla's UTF-8 POST URLs in the
-TWiki Feb2003 release - encoding is no longer needed since UTF-URLs are now
-directly supported, but it is provided for backward compatibility with
-skins that may still be using the deprecated %INTURLENCODE%.
-
-=cut
-
-sub handleIntUrlEncode
-{
-    my( $theStr ) = @_;
-
+# This routine was introduced to URL encode Mozilla UTF-8 POST URLs in the
+# TWiki Feb2003 release - encoding is no longer needed since UTF-URLs are now
+# directly supported, but it is provided for backward compatibility with
+# skins that may still be using the deprecated %INTURLENCODE%.
+sub _handleINTURLENCODE {
+    my $params = shift;
     # Just strip double quotes, no URL encoding - Mozilla UTF-8 URLs
     # directly supported now
-    $theStr =~ s/^"(.*)"$/$1/;	
-    return $theStr;
+    return $params->{_DEFAULT};
 }
 
 =pod
 
----++ sub handleEnvVariable (  $theVar  )
+---++ sub searchableTopic (  $topic  )
 
-Not yet documented.
+Space out the topic name for a search, by inserting " *" at
+the start of each component word.
 
 =cut
 
-sub handleEnvVariable
+sub searchableTopic
 {
-    my( $theVar ) = @_;
-    my $value = $ENV{$theVar} || "";
-    return $value;
+    my( $topic ) = @_;
+    # FindMe -> Find\s*Me
+    $topic =~ s/([$regex{lowerAlpha}]+)([$regex{upperAlpha}$regex{numeric}]+)/$1%20*$2/go;   # "%20*" is " *" - I18N: only in ASCII-derived charsets
+    return $topic;
 }
 
-=pod
+sub _handleSPACEDTOPIC {
+    my ( $params, $theTopic ) = @_;
 
----++ sub handleTmplP (  $theParam  )
+    return _urlEncode( searchableTopic( $theTopic ));
+}
 
-Not yet documented.
+sub _handleICON {
+    my $params = shift;
 
-=cut
+    my $theParam = $params->{_DEFAULT};
 
-sub handleTmplP
-{
-    my( $theParam ) = @_;
-
-    $theParam = extractNameValuePair( $theParam );
-    my $value = &TWiki::Store::handleTmplP( $theParam );
+    my $value = TWiki::Render::filenameToIcon( "file.$theParam" );
     return $value;
 }
 
-# =========================
-# Create spaced-out topic name for Ref-By search 
-=pod
+sub _handleRELATIVETOPICPATH {
+    my ( $params, $theTopic, $theWeb ) = @_;
 
----++ sub handleSpacedTopic (  $theTopic  )
+    my $theStyleTopic = $params->{_DEFAULT};
 
-Not yet documented.
+    return "" unless $theStyleTopic;
 
-=cut
-
-sub handleSpacedTopic
-{
-    my( $theTopic ) = @_;
-    my $spacedTopic = $theTopic;
-    $spacedTopic =~ s/($regex{singleLowerAlphaRegex}+)($regex{singleUpperAlphaNumRegex}+)/$1%20*$2/go;   # "%20*" is " *" - I18N: only in ASCII-derived charsets
-    return $spacedTopic;
+    my $theRelativePath;
+    # if there is no dot in $theStyleTopic, no web has been specified
+    if ( index( $theStyleTopic, "." ) == -1 ) {
+        # add local web
+        $theRelativePath = $theWeb . "/" . $theStyleTopic;
+    } else {
+        $theRelativePath = $theStyleTopic; #including dot
+    }
+    # replace dot by slash is not necessary; TWiki.MyTopic is a valid url
+    # add ../ if not already present to make a relative file reference
+    if ( index( $theRelativePath, "../" ) == -1 ) {
+        $theRelativePath = "../" . $theRelativePath;
+    }
+    return $theRelativePath;
 }
 
-# =========================
-=pod
+sub _handleATTACHURLPATH {
+    my ( $params, $theTopic, $theWeb ) = @_;
 
----++ sub handleIcon (  $theParam  )
-
-Not yet documented.
-
-=cut
-
-sub handleIcon
-{
-    my( $theParam ) = @_;
-
-    $theParam = extractNameValuePair( $theParam );
-    my $value = &TWiki::Attach::filenameToIcon( "file.$theParam" );
-    return $value;
+    return nativeUrlEncode( "$pubUrlPath/$theWeb/$theTopic" );
 }
 
 =pod
 
----++ sub handleRelativeTopicPath ( $styleTopic, $web )
+---++ processTags( \$text, $topic, $web, $verb, $incs )
+Expands variables by replacing the variables with their
+values. Some example variables: %<nop>TOPIC%, %<nop>SCRIPTURL%,
+%<nop>WIKINAME%, etc.
 
-Not yet documented.
+$web and $incs are passed in for recursive include expansion. They can
+safely be undef.
 
-=cut
+The rules for tag expansion are:
+   1 Tags are expanded left to right, in the order they are encountered.
+   1 Tags are recursively expanded as soon as they are encountered - the algorithm is inherently single-pass
+   1 A tag is not ""encountered" until the matching }% has been seen, by which time all tags in parameters will have been expanded
+   1 Tag expansions that create new tags recursively are limited to a set number of hierarchical levels of expansion
 
-sub handleRelativeTopicPath
-{
-       my( $theStyleTopic, $theWeb ) = @_;
+Formerly known as handleInternalTags, but renamed when it was rewritten
+because the old name clashes with the namespace of handlers.
 
-       if ( !$theStyleTopic ) {
-               return "";
-       }
-       my $theRelativePath;
-       # if there is no dot in $theStyleTopic, no web has been specified
-       if ( index( $theStyleTopic, "." ) == -1 ) {
-               # add local web
-               $theRelativePath = $theWeb . "/" . $theStyleTopic;
-       } else {
-               $theRelativePath = $theStyleTopic; #including dot
-       }
-       # replace dot by slash is not necessary; TWiki.MyTopic is a valid url
-       # add ../ if not already present to make a relative file reference
-       if ( index( $theRelativePath, "../" ) == -1 ) {
-               $theRelativePath = "../" . $theRelativePath;
-       }
-       return $theRelativePath;
-}
-
-=pod
-
----++ handleInternalTags( $text, $topic, $web )
-
-Modifies $text in-place, replacing variables internal to TWiki with their
-values.  Some example variables: %<nop>TOPIC%, %<nop>SCRIPTURL%, %<nop>WIKINAME%, etc.
-
 =cut
 
-sub handleInternalTags
-{
-    # modify arguments directly, i.e. call by reference
-    # $_[0] is text
-    # $_[1] is topic
-    # $_[2] is web
+sub processTags {
+    my $text = shift; # reference
+    my ( $topic, $web ) = @_;
 
-    # Make Edit URL unique for every edit - fix for RefreshEditPage.
-    $_[0] =~ s!%EDITURL%!"$dispScriptUrlPath/edit$scriptSuffix/%WEB%/%TOPIC%\?t=" . time()!ge;
+    my $memTopic = $sessionInternalTags{TOPIC};
+    my $memWeb = $sessionInternalTags{WEB};
+    my $memEurl = $sessionInternalTags{EDITURL};
 
-    $_[0] =~ s/%NOP{(.*?)}%/$1/gs;  # remove NOP tag in template topics but show content
-    $_[0] =~ s/%NOP%/<nop>/g;
-    $_[0] =~ s/%TMPL\:P{(.*?)}%/&handleTmplP($1)/ge;
-    $_[0] =~ s/%SEP%/&handleTmplP('"sep"')/ge;
+    $sessionInternalTags{TOPIC} = $topic;
+    $sessionInternalTags{WEB} = $web;
+    # Make Edit URL unique - fix for RefreshEditPage.
+    $sessionInternalTags{EDITURL} =
+      "$dispScriptUrlPath/edit$scriptSuffix/$web/$topic\?t=" . time();
 
-    $_[0] =~ s/%HTTP_HOST%/&handleEnvVariable('HTTP_HOST')/ge;
-    $_[0] =~ s/%REMOTE_ADDR%/&handleEnvVariable('REMOTE_ADDR')/ge;
-    $_[0] =~ s/%REMOTE_PORT%/&handleEnvVariable('REMOTE_PORT')/ge;
-    $_[0] =~ s/%REMOTE_USER%/&handleEnvVariable('REMOTE_USER')/ge;
+    # SMELL: why is this done every time, and not statically during
+    # template loading?
+    $$text =~ s/%NOP{(.*?)}%/$1/gs;  # remove NOP tag in template topics but show content
+    $$text =~ s/%NOP%/<nop>/g;
+    my $sep = TWiki::Templates::expandTemplate('"sep"');
+    $$text =~ s/%SEP%/$sep/g;
 
-    $_[0] =~ s/%TOPIC%/$_[1]/g;
-    $_[0] =~ s/%BASETOPIC%/$topicName/g;
-    $_[0] =~ s/%INCLUDINGTOPIC%/$includingTopicName/g;
-    $_[0] =~ s/%SPACEDTOPIC%/&handleSpacedTopic($_[1])/ge;
-    $_[0] =~ s/%WEB%/$_[2]/g;
-    $_[0] =~ s/%BASEWEB%/$webName/g;
-    $_[0] =~ s/%INCLUDINGWEB%/$includingWebName/g;
+    # NOTE TO DEBUGGERS
+    # The depth parameter in the following call controls the maximum number
+    # of levels of expansion. If it is set to 1 then only tags in the
+    # topic will be expanded; tags that they in turn generate will be
+    # left unexpanded. If it is set to 2 then the expansion will stop after
+    # the first recursive inclusion, and so on. This is incredible useful
+    # when debugging The default is set to 16
+    # to match the original limit on search expansion, though this of
+    # course applies to _all_ tags and not just search.
+    $$text = _processTags( $$text, 16, "", @_ );
 
-    # I18N information
-    $_[0] =~ s/%CHARSET%/$siteCharset/g;
-    $_[0] =~ s/%SHORTLANG%/$siteLang/g;
-    $_[0] =~ s/%LANG%/$siteFullLang/g;
+    $sessionInternalTags{TOPIC} = $memTopic;
+    $sessionInternalTags{WEB} = $memWeb;
+    $sessionInternalTags{EDITURL} = $memEurl;
+}
 
-    $_[0] =~ s/%TOPICLIST{(.*?)}%/&handleWebAndTopicList($1,'0')/ge;
-    $_[0] =~ s/%WEBLIST{(.*?)}%/&handleWebAndTopicList($1,'1')/ge;
+# Process TWiki %TAGS{}% by parsing the input tokenised into
+# % separated sections. The parser is a simple stack-based parse,
+# sufficient to ensure nesting of tags is correct, but no more
+# than that.
+# $depth limits the number of recursive expansion steps that
+# can be performed on expanded tags.
+sub _processTags {
+    my $text = shift;
 
-    # URLs and paths
-    $_[0] =~ s/%WIKIHOMEURL%/$wikiHomeUrl/g;
-    $_[0] =~ s/%SCRIPTURL%/$urlHost$dispScriptUrlPath/g;
-    $_[0] =~ s/%SCRIPTURLPATH%/$dispScriptUrlPath/g;
-    $_[0] =~ s/%SCRIPTSUFFIX%/$scriptSuffix/g;
-    $_[0] =~ s/%PUBURL%/$urlHost$pubUrlPath/g;
-    $_[0] =~ s/%PUBURLPATH%/$pubUrlPath/g;
-    $_[0] =~ s/%RELATIVETOPICPATH{(.*?)}%/&handleRelativeTopicPath($1,$_[2])/ge;
+    return "" unless defined( $text );
 
-    # Attachments
-    $_[0] =~ s!%ATTACHURL%!$urlHost%ATTACHURLPATH%!g;
-    # I18N: URL-encode full web, topic and filename to the native
-    # $siteCharset for attachments viewed from browsers that use UTF-8 URL,
-    # unless we are in UTF-8 mode or working on EBCDIC mainframe.
-    # Include the filename suffixed to %ATTACHURLPATH% - a hack, but required
-    # for migration purposes
-    $_[0] =~ s!%ATTACHURLPATH%/($regex{filenameRegex})!&handleNativeUrlEncode("$pubUrlPath/$_[2]/$_[1]/$1",1)!ge;
-    $_[0] =~ s!%ATTACHURLPATH%!&handleNativeUrlEncode("$pubUrlPath/$_[2]/$_[1]",1)!ge;	# No-filename case
-    $_[0] =~ s/%ICON{(.*?)}%/&handleIcon($1)/ge;
+    my $depth = shift;
+    my $expanding = shift;
 
-    # URL encoding
-    $_[0] =~ s/%URLPARAM{(.*?)}%/&handleUrlParam($1)/ge;
-    $_[0] =~ s/%(URL)?ENCODE{(.*?)}%/&handleUrlEncode($2,1)/ge; 	# ENCODE is documented, URLENCODE is legacy
-    $_[0] =~ s/%INTURLENCODE{(.*?)}%/&handleIntUrlEncode($1)/ge;	# Deprecated - not needed with UTF-8 URL support
-    
-    # Dates and times
-    $_[0] =~ s/%DATE%/&formatTime(time(), "\$day \$mon \$year", "gmtime")/ge; 					# Deprecated, but used in signatures
-    $_[0] =~ s/%GMTIME%/&handleTime("","gmtime")/ge;
-    $_[0] =~ s/%GMTIME{(.*?)}%/&handleTime($1,"gmtime")/ge;
-    $_[0] =~ s/%SERVERTIME%/&handleTime("","servertime")/ge;
-    $_[0] =~ s/%SERVERTIME{(.*?)}%/&handleTime($1,"servertime")/ge;
-    $_[0] =~ s/%DISPLAYTIME%/&handleTime("", $displayTimeValues)/ge;
-    $_[0] =~ s/%DISPLAYTIME{(.*?)}%/&handleTime($1, $displayTimeValues)/ge;
+    # my( $topic, $web, $verbatim, $processedTopics ) = @_;
 
-    $_[0] =~ s/%WIKIVERSION%/$wikiversion/g;
-    $_[0] =~ s/%PLUGINVERSION{(.*?)}%/TWiki::Plugins::getPluginVersion($1)/ge;
-    $_[0] =~ s/%USERNAME%/$userName/g;
-    $_[0] =~ s/%WIKINAME%/$wikiName/g;
-    $_[0] =~ s/%WIKIUSERNAME%/$wikiUserName/g;
-    $_[0] =~ s/%WIKITOOLNAME%/$wikiToolName/g;
-    $_[0] =~ s/%MAINWEB%/$mainWebname/g;
-    $_[0] =~ s/%TWIKIWEB%/$twikiWebname/g;
-    $_[0] =~ s/%HOMETOPIC%/$mainTopicname/g;
-    $_[0] =~ s/%WIKIUSERSTOPIC%/$wikiUsersTopicname/g;
-    $_[0] =~ s/%WIKIPREFSTOPIC%/$wikiPrefsTopicname/g;
-    $_[0] =~ s/%WEBPREFSTOPIC%/$webPrefsTopicname/g;
-    $_[0] =~ s/%NOTIFYTOPIC%/$notifyTopicname/g;
-    $_[0] =~ s/%STATISTICSTOPIC%/$statisticsTopicname/g;
-    $_[0] =~ s/%STARTINCLUDE%//g;
-    $_[0] =~ s/%STOPINCLUDE%//g;
-    $_[0] =~ s/%SECTION{(.*?)}%//g;
-    $_[0] =~ s/%ENDSECTION%//g;
-    my $ok = 16; # SEARCH may be nested up to 16 times
-    TRY: while( $_[0] =~ s/%SEARCH{(.*?)}%/&handleSearchWeb($1,$_[2],$_[1])/ge ) {
-        last TRY unless( --$ok );
+    unless ( $depth ) {
+        my $mess = "Max recursive depth reached: $expanding";
+        writeWarning( $mess );
+        return $text;
+        #return _inlineError( $mess );
     }
-    $_[0] =~ s/%METASEARCH{(.*?)}%/&handleMetaSearch($1)/ge;
-    $_[0] =~ s/%FORMFIELD{(.*?)}%/&TWiki::Render::getFormField($_[2],$_[1],$1)/ge;
 
-    $_[0] =~ s/%REVINFO%/handleRevisionInfo( $_[2], $_[1] )/ge;
-    $_[0] =~ s/%REVINFO{(.*?)}%/handleRevisionInfo( $_[2], $_[1], $1 )/ge;
-}
+    my @queue = split( /%/, $text );
 
-=pod
+    my $sep = "";
+    $sep = "%" if ( $text =~ /^%/ );
+    my @stack;
+    my $cycle = 0;
+    #my $tell = 1;
+    push( @stack, "" );
+    while ( scalar( @queue )) {
+        my $token = shift( @queue );
+        #print STDERR "PROCESSING $token \n" if $tell;
+        my $simple = 0;
 
----++ takeOutVerbatim( $text, \@verbatimBuffer )
-Return value: $textWithoutVerbatim
+        $cycle++;
 
-Searches through $text and extracts &lt;verbatim> blocks, appending each
-onto the end of the @verbatimBuffer array and replacing it with a token
-string which is not affected by TWiki rendering.  The text after these
-substitutions is returned.
+        if ( $sep && $token =~ /^[A-Z][A-Z0-9_:]*{/ ) {
+            # a parameterised tag; push a new context
+            push( @stack, $token );
+            $simple = $token =~ /}$/;
+            $token = "";
+            # fall through to handle close }%
+        } elsif ( $sep && $token =~ /^[A-Z][A-Z0-9_:]*$/ ) {
+            #print STDERR "PUSHING $token ",$stack[$#stack],"\n" if $tell;
+            push( @stack, "" ); # push a context
+            $simple = 1;
+            # fall through to handle close }%
+        }
 
-This function is designed to preserve the contents of verbatim blocks
-through some rendering operation.  The general sequence of calls for
-this use is something like this:
-
-   $textToRender = takeOutVerbatim($inputText, \@verbatimBlocks);
-   $renderedText = performSomeRendering($textToRender);
-   $resultText = putBackVerbatim($renderedText, "pre", @verbatimBlocks);
-
-Note that some changes are made to verbatim blocks here: &lt; and > are replaced
-by their HTML entities &amp;lt; and &amp;gt;, and the actual &lt;verbatim>
-tags are replaced with &lt;pre> tags so that the text is rendered truly
-"verbatim" by a browser.  If this is not desired, pass "verbatim" as the
-second parameter of putBackVerbatim instead of "pre".
-
-=cut
-
-sub takeOutVerbatim
-{
-    my( $intext, $verbatim ) = @_;	# $verbatim is ref to array
-    
-    if( $intext !~ /<verbatim>/oi ) {
-        return( $intext );
-    }
-    
-    # Exclude text inside verbatim from variable substitution
-    
-    my $tmp = "";
-    my $outtext = "";
-    my $nesting = 0;
-    my $verbatimCount = $#{$verbatim} + 1;
-    
-    foreach( split( /\n/, $intext ) ) {
-        if( /^(\s*)<verbatim>\s*$/i ) {
-            $nesting++;
-            if( $nesting == 1 ) {
-                $outtext .= "$1%_VERBATIM$verbatimCount%\n";
-                $tmp = "";
-                next;
+        if ( $#stack && ( $simple || $token =~ /}$/ )) {
+            # close of a tag. Pop the context.
+            my $expr = pop( @stack ) . $token;
+            my ( $tag, $args );
+            if( $expr =~ /^(.*?)\{(.*)\}$/s ) {
+                ( $tag, $args) = ( $1, $2 );
+            } else {
+                ( $tag, $args ) = ( $expr, undef );
             }
-        } elsif( m|^\s*</verbatim>\s*$|i ) {
-            $nesting--;
-            if( ! $nesting ) {
-                $verbatim->[$verbatimCount++] = $tmp;
-                next;
+            #print STDERR "expand $expr ",$stack[$#stack],"\n" if $tell;
+            my ( $r, $e ) = _handleTag( $expr, $tag, $args, @_ );
+            if ( $r ) {
+                # recursively expand what we just got
+                $e = _processTags( $e, $depth - 1,
+                                   "$expanding:$depth/$tag", @_ );
+                if ( defined( $e ) && $e !~ /\n/ ) {
+                    #print STDERR "EXPANDED $tag -> $e\n" if $tell;
+                    #print STDERR "Added to ",$stack[$#stack],"\n" if $tell;
+                }
+                $sep = "";
+            } else {
+                #print STDERR "EXPANSION OF $tag ( $expr )failed\n" if $tell;
+                $e = "%$expr";
             }
+            $stack[$#stack] .= $e;
+            next;
         }
 
-        if( $nesting ) {
-            $tmp .= "$_\n";
-        } else {
-            $outtext .= "$_\n";
-        }
+        $sep = "" if $cycle == 1;
+        # something else separated by % signs
+        #print STDERR "ADDED $sep$token ".ord($token),"\n" if $tell;
+        $stack[$#stack] .= "$sep$token";
+        $sep = "%";
     }
-    
-    # Deal with unclosed verbatim
-    if( $nesting ) {
-        $verbatim->[$verbatimCount] = $tmp;
+
+    # Run out of input. Close open tags.
+    while ( $#stack ) {
+        my $expr = pop( @stack );
+        writeWarning( "Unclosed tag $expr...");
+        $stack[$#stack] .= $expr;
     }
-       
-    return $outtext;
+
+    return pop( @stack );
 }
 
-=pod
+# Handle expansion of 'constant' tags (as against preference tags)
+# $eref is a reference to the flag that records the number of
+# successful expansions on a single pass through the text
+# $result is (initially) the whole tag expression
+# $tag is the tag part
+# $args is the bit in the {} (if there are any)
+sub _handleTag {
+    my $result = shift; # whole expression
+    my $tag = shift;    # tag subexpression
+    my $args = shift;
+    # my( $topic, $web, $verbatim, $processedTopics ) = @_;
 
----++putBackVerbatim( $textWithoutVerbatim, $putBackType, @verbatimBuffer )
-Return value: $textWithVerbatim
+    my $res;
 
-This function reverses the actions of takeOutVerbatim above.  See the text for
-takeOutVerbatim for a more thorough description.
+    if ( defined( $preferencesTags{$tag} )) {
+        $res = $preferencesTags{$tag};
+    } elsif ( defined( $sessionInternalTags{$tag} )) {
+        $res = $sessionInternalTags{$tag};
+    } elsif ( defined( $staticInternalTags{$tag} )) {
+        $res = $staticInternalTags{$tag};
+    } elsif ( defined( $dynamicInternalTags{$tag} )) {
+        my %params = extractParameters( $args );
 
-Set $putBackType to 'verbatim' to get back original text, or to 'pre' to
-convert to HTML readable verbatim text.
-
-=cut
-
-sub putBackVerbatim
-{
-    my( $text, $type, @verbatim ) = @_;
-    
-    for( my $i=0; $i<=$#verbatim; $i++ ) {
-        my $val = $verbatim[$i];
-        if( $type ne "verbatim" ) {
-            $val =~ s/&/&amp;/g;
-            $val =~ s/</&lt;/g;
-            $val =~ s/>/&gt;/g;
-            $val =~ s/\t/   /g; # A shame to do this, but been in TWiki.org have converted
-                                # 3 spaces to tabs since day 1
-        }
-        $text =~ s|%_VERBATIM$i%|<$type>\n$val</$type>|;
+        $res = &{$dynamicInternalTags{$tag}}( \%params, @_ );
     }
 
-    return $text;
+    #if ( defined( $res )) {
+    #    print STDERR "EXPAND $tag -> $res\n";
+    #}
+    return ( defined( $res ), $res );
 }
 
 =pod
 
----++ handleCommonTags( $text, $topic, $web, @processedTopics )
-Return value: $handledText
+---++ handleCommonTags( $text, $topic, $web ) => processed $text
+Processes %<nop>VARIABLE%, and %<nop>TOC% syntax; also includes
+"commonTagsHandler" plugin hook.
 
-Processes %<nop>VARIABLE%, %<nop>TOC%, and %<nop>INCLUDE% syntax; also includes
-"commonTagsHandler" plugin hook.  If processing an included topic,
-@processedTopics should be a list of topics already included, or in
-the process of being included.
-
 Returns the text of the topic, after file inclusion, variable substitution,
 table-of-contents generation, and any plugin changes from commonTagsHandler.
 
 =cut
 
-sub handleCommonTags
-{
-    my( $text, $theTopic, $theWeb, @theProcessedTopics ) = @_;
+sub handleCommonTags {
+    my( $text, $theTopic, $theWeb ) = @_;
 
-    # PTh 22 Jul 2000: added $theWeb for correct handling of %INCLUDE%, %SEARCH%
     if( !$theWeb ) {
         $theWeb = $webName;
     }
 
-    # TWiki Plugin Hook (for cache Plugins only)
-    &TWiki::Plugins::beforeCommonTagsHandler( $text, $theTopic, $theWeb );
-
     my @verbatim = ();
-    $text = takeOutVerbatim( $text, \@verbatim );
+    my $theProcessedTopics = {};
 
+    # Plugin Hook (for cache Plugins only)
+    TWiki::Plugins::beforeCommonTagsHandler( $text, $theTopic, $theWeb );
+
+    $text = TWiki::Render::takeOutBlocks( $text, "verbatim", \@verbatim );
+
     # Escape rendering: Change " !%VARIABLE%" to " %<nop>VARIABLE%", for final " %VARIABLE%" output
     $text =~ s/(\s)\!\%([A-Z])/$1%<nop>$2/g;
 
-    # handle all preferences and internal tags (for speed: call by reference)
-    $includingWebName = $theWeb;
-    $includingTopicName = $theTopic;
-    &TWiki::Prefs::handlePreferencesTags( $text );
-    handleInternalTags( $text, $theTopic, $theWeb );
+    my $memW = $sessionInternalTags{INCLUDINGWEB};
+    my $memT = $sessionInternalTags{INCLUDINGTOPIC};
+    $sessionInternalTags{INCLUDINGWEB} = $theWeb;
+    $sessionInternalTags{INCLUDINGTOPIC} = $theTopic;
 
-    # recursively process multiple embedded %INCLUDE% statements and prefs
-    $text =~ s/%INCLUDE{(.*?)}%/&handleIncludeFile($1, $theTopic, $theWeb, \@verbatim, @theProcessedTopics )/ge;
+    processTags( \$text, $theTopic, $theWeb,
+                        \@verbatim, $theProcessedTopics );
 
-    # TWiki Plugin Hook
-    &TWiki::Plugins::commonTagsHandler( $text, $theTopic, $theWeb, 0 );
+    # Plugin Hook
+    TWiki::Plugins::commonTagsHandler( $text, $theTopic, $theWeb, 0 );
 
-    # handle tags again because of plugin hook
-    &TWiki::Prefs::handlePreferencesTags( $text );
-    handleInternalTags( $text, $theTopic, $theWeb );
-    $text =~ s/%INCLUDE{(.*?)}%/&handleIncludeFile($1, $theTopic, $theWeb, \@verbatim, @theProcessedTopics )/ge; 
+    # process tags again because plugin hook may have added more in
+    processTags( \$text, $theTopic, $theWeb,
+                        \@verbatim, $theProcessedTopics );
 
-    $text =~ s/%TOC{([^}]*)}%/&handleToc($text,$theTopic,$theWeb,$1)/ge;
-    $text =~ s/%TOC%/&handleToc($text,$theTopic,$theWeb,"")/ge;
+    $sessionInternalTags{INCLUDINGWEB} = $memW;
+    $sessionInternalTags{INCLUDINGTOPIC} = $memT;
 
-    # Codev.FormattedSearchWithConditionalOutput: remove <nop> lines, possibly introduced by
-    # SEARCHes with conditional CALC. This needs to be done after CALC and before table rendering
+    # Codev.FormattedSearchWithConditionalOutput: remove <nop> lines,
+    # possibly introduced by SEARCHes with conditional CALC. This needs
+    # to be done after CALC and before table rendering
+    # SMELL: is this a hack? Looks like it....
     $text =~ s/^<nop>\r?\n//gm;
 
-    # Ideally would put back in getRenderedVersion rather than here which would save removing
-    # it again!  But this would mean altering many scripts to pass back verbatim
-    $text = putBackVerbatim( $text, "verbatim", @verbatim );
+    $text = TWiki::Render::putBackBlocks( $text, \@verbatim, "verbatim" );
 
     # TWiki Plugin Hook (for cache Plugins only)
-    &TWiki::Plugins::afterCommonTagsHandler( $text, $theTopic, $theWeb );
+    TWiki::Plugins::afterCommonTagsHandler( $text, $theTopic, $theWeb );
 
     return $text;
 }
 
-# =========================
-=pod
-
----++ sub handleMetaTags (  $theWeb, $theTopic, $text, $meta, $isTopRev  )
-
-| TODO | move to Render.pm or Meta.pm of Forms.pm |
-| | used to render the non-active modes of META data (view, preview ...) |
-Not yet documented.
-
-=cut
-
-sub handleMetaTags
-{
-    my( $theWeb, $theTopic, $text, $meta, $isTopRev ) = @_;
-
-    $text =~ s/%META{\s*"form"\s*}%/&TWiki::Render::renderFormData( $theWeb, $theTopic, $meta )/ge;    #this renders META:FORM and META:FIELD
-    $text =~ s/%META{\s*"formfield"\s*(.*?)}%/&TWiki::Render::renderFormField( $meta, $1 )/ge;                 #TODO: what does this do? (is this the old forms system, and so can be deleted)
-    $text =~ s/%META{\s*"attachments"\s*(.*)}%/&TWiki::Attach::renderMetaData( $theWeb,
-                                                $theTopic, $meta, $1, $isTopRev )/ge;                                       #renders attachment tables
-    $text =~ s/%META{\s*"moved"\s*}%/&TWiki::Render::renderMoved( $theWeb, $theTopic, $meta )/ge;      #render topic moved information
-    $text =~ s/%META{\s*"parent"\s*(.*)}%/&TWiki::Render::renderParent( $theWeb, $theTopic, $meta, $1 )/ge;    #render the parent information
-
-    $text = handleCommonTags( $text, $theTopic );
-    $text = TWiki::Render::getRenderedVersion( $text, $theWeb );
-
-    return $text;
-}
-
 =end twiki
 
 =cut
